/*  Following courtesy kdq (Kevin D. Quitt)
*/
#define TRUE	(1==1)
#define FALSE	(1!=1)
#define TB {9,0}
#define SP {0x20,0}


/* Special handling table */
struct
   {
    char name[10];			/* Name (for reference and display) */
    char auto_fill_p;			/* Want auto fill?		    */
    char tab_size;			/* Preferred tab spacing	    */
    struct
       {
	char col;			/* Comment column		    */
	char over[5];			/* String to insert if past col	    */
	char start[5];			/* String used to start comment	    */
	char end[5];			/* String used to end comment	    */
	char offset;
       }
    comment;				/* Where to put cursor		    */
    struct
       {
	char begin[10];			/* Begin keyword		    */
	char end[10];
       }
    block;
   }					/* End keyword			    */
language_info[7] = {
/*			 ---------   Comment   ---------   --- Block ---
  Name,	     Fill, Tab, {Col, Over, Start,  End,  Offset}, {Begin,   End} */
{ "nul",     TRUE,  8, { 72,  "",  "",	   "",	    0 }, {   0,	    0	   }},
{ "c-mode",  FALSE, 8, { 40,  TB,  "/* ",  "*/",    2 }, { "{",	    "}"	   }},
{ "pascal",  FALSE, 4, { 40,  TB,  "{ ",   "\t}",   2 }, { "Begin", "End"  }},
{ "plm",     FALSE, 4, { 40,  TB,  "/* ",  "\t*/",  3 }, { "DO;",   "END;" }},
{ "asm",     FALSE, 8, { 40,  SP,  "; ",   "",	    0 }, { "",	    ""	   }},
{ "text",    TRUE,  8, { 72,  "",  "",	   "",	    0 }, {  0,	    0	   }},
{ "",	      0,    0, { 0,   "",  "",	   "",	    0 }, { "",	    ""	  }}};
/* End of list */
#define LANGUAGE_UNKNOWN    (0)
#define LANGUAGE_C	    (1)
#define LANGUAGE_PASCAL	    (2)
#define LANGUAGE_PLM	    (3)
#define LANGUAGE_ASSEMBLY   (4)
#define LANGUAGE_TEXT	    (5)

buffer short margin_right = 72;		/* right-hand margin		    */
buffer char auto_fill_indents = 0;	/* does auto-fill do indenting?	    */
buffer char language_mode = LANGUAGE_UNKNOWN;  /* language special handling mode*/

/*  Used by set-number and next-number 21-Jun-90 11:35:43 by Kevin D. Quitt
*/
int number_next = 0;

/*  Used by indentation routines, to back an OPEN_BRACE away from the tab
*/
int outdent = 1;	/* # of chars to back up if open brace. */


buffer int graphic_mode = 0;		/* I like it per window		    */
